////////////////////////////////
////                        ////
////    Global Variables    ////
////                        ////
////////////////////////////////
extern int MagicNumber=10001;
int Slippage=3;
double MyPoint=Point;
extern int Step=5;

/////////////////////
////             ////
////    START    ////
////             ////
/////////////////////
int start()
{ 
  if(Digits==3 || Digits==5)
  MyPoint=Point*10;
  
  if(OrdersTotal()==0)
  {
    if(MathRand()%2==0)
    openBuy();
    else
    openSell();
  }
  
  if(OrdersTotal()==1)
  {
    modifySingleOrder();
    if(OrderSelect(OrdersTotal()-1, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_BUY)
      {
        if(Ask<avgOPP4BuyOrders()-Step*MyPoint)
        {
          openSell();
        }
      }
      if(OrderType()==OP_SELL)
      {
        if(Bid>avgOPP4SellOrders()+Step*MyPoint)
        {
          openBuy();
        }
      }
    }
  }
  
  if(OrdersTotal()>1)
  {
    double Divergence=avgOPP4BuyOrders()-avgOPP4SellOrders();
    double BuyOPP=avgOPP4BuyOrders();
    double SellOPP=avgOPP4SellOrders();
    
    Comment("Point: ", Point,
            "\nBid: ", Bid,
            "\nAsk: ", Ask);
    
    if(sumOfAllBuyOrdersLots()>sumOfAllSellOrdersLots())
    {
      modifyAllAtHigh();
      if(Ask<avgOPP4BuyOrders()-Divergence)
      openSell();
    }
    if(sumOfAllSellOrdersLots()>sumOfAllBuyOrdersLots())
    {
      modifyAllAtLow();
      if(Bid>avgOPP4SellOrders()+Divergence)
      openBuy();
    }
  }
  
 /* if(OrdersTotal()>1)
  {
    double Divergence=avgOPP4BuyOrders()-avgOPP4SellOrders();
    double BuyOPP=avgOPP4BuyOrders();
    double SellOPP=avgOPP4SellOrders();
      
    if(sumOfAllBuyOrdersLots()>sumOfAllSellOrdersLots())
    {
      if(Bid<BuyOPP-Divergence)
      {
        openSell();
      }
      if((Bid<BuyOPP+Divergence) && (Ask<SellOPP+(Divergence*2)))
      {
        for(int i=OrdersTotal()-1; i>=0; i--)
        {
          if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
          {
            if(OrderType()==OP_BUY)
            {
              if(OrderModify(OrderTicket(), OrderOpenPrice(), 0, BuyOPP+Divergence, 0, Red))
              return true;
            }
          }
          if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
          {
            if(OrderType()==OP_SELL)
            {
              if(OrderModify(OrderTicket(), OrderOpenPrice(), SellOPP+(Divergence*2), 0, 0, Red))
              return true;
            }
          }
        }
      }
      //if((Bid>avgOPP4BuyOrders()+Divergence) && (Ask>avgOPP4SellOrders()+(Divergence*2)))
    }
    if(sumOfAllSellOrdersLots()>sumOfAllBuyOrdersLots())
    {
      if(Ask>SellOPP+Divergence)
      {
        openBuy();
      }
      if((Bid>BuyOPP-(Divergence*2)) && (Ask>SellOPP-Divergence))
      { 
        for(int k=OrdersTotal()-1; k>=0; k--)
        {
          if(OrderSelect(k, SELECT_BY_POS, MODE_TRADES))
          {
            if(OrderType()==OP_BUY)
            {
              if(OrderModify(OrderTicket(), OrderOpenPrice(), 0, BuyOPP-(Divergence*2), 0, Red))
              return true;
            }
          }
          if(OrderSelect(k, SELECT_BY_POS, MODE_TRADES))
          {
            if(OrderType()==OP_SELL)
            {
              if(OrderModify(OrderTicket(), OrderOpenPrice(), 0, SellOPP-Divergence, 0, Red))
              return true;
            }
          }
        }
      }
    }
  }*/
  return true;
}

////////////////////////////////////////////////////////////////
////                                                        ////
////                    Custom Functions                    ////
////                                                        ////
////////////////////////////////////////////////////////////////
double getLots()
{
  double baseLot=0.01;
  double lotSize=0;
  
  if(OrdersTotal()==0)
  return baseLot;
  if(OrdersTotal()==1)
  {
    if(OrderSelect(OrdersTotal()-1, SELECT_BY_POS, MODE_TRADES))
    {
      return (OrderLots()*2)+baseLot;
    }
  }
  if(OrdersTotal()>1)
  {
    return maxLot()*2;
  }
  return true;
}

int numOfBuyOrders()
{
  int BuyOrders=0;
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_BUY)
      BuyOrders++;
    }    
  }
  return BuyOrders;
}

int numOfSellOrders()
{
  int SellOrders=0;
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_SELL)
      SellOrders++;
    }
  }
  return SellOrders;
}

double sumOfAllBuyOrdersLots()
{
  double BuyLots=0;
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_BUY)
      BuyLots=BuyLots+OrderLots();
    }
  }
  return BuyLots;
}

double sumOfAllSellOrdersLots()
{
  double SellLots=0;
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_SELL)
      SellLots=SellLots+OrderLots();
    }
  }
  return SellLots;
}

double avgOPP4BuyOrders()
{
  double sumOfAllBuyOPP=0;
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_BUY)
      sumOfAllBuyOPP=sumOfAllBuyOPP+OrderOpenPrice();
    }
  }
  return sumOfAllBuyOPP/numOfBuyOrders();
}

double avgOPP4SellOrders()
{
  double sumOfAllSellOPP=0;
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_SELL)
      sumOfAllSellOPP=sumOfAllSellOPP+OrderOpenPrice();
    }
  }
  return sumOfAllSellOPP/numOfSellOrders();
}

int openSell()
{
  if(OrderSend(Symbol(),OP_SELL,getLots(),Bid,Slippage,0,0,"EA Generator www.ForexEAdvisor.com",MagicNumber,0,Red))
  return true;
  return true;
}

int openBuy()
{
  if(OrderSend(Symbol(),OP_BUY,getLots(),Ask,Slippage,0,0,"EA Generator www.ForexEAdvisor.com",MagicNumber,0,Blue))
  return true;
  return true;
}

int modifySingleOrder()
{
  if(OrdersTotal()==1)
  {
    if(OrderSelect(OrdersTotal()-1, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_BUY)
      {
        if(Bid<avgOPP4BuyOrders()+Step*MyPoint)
        {
          if(OrderTakeProfit()!=avgOPP4BuyOrders()+Step*MyPoint)
          {
            if(OrderModify(OrderTicket(), OrderOpenPrice(), 0, avgOPP4BuyOrders()+Step*MyPoint, 0, Red))
            return true;
          }
        }
      }
      if(OrderType()==OP_SELL)
      {
        if(Ask>avgOPP4SellOrders()-Step*MyPoint)
        {
          if(OrderTakeProfit()!=avgOPP4SellOrders()-Step*MyPoint)
          {
            if(OrderModify(OrderTicket(), OrderOpenPrice(), 0, avgOPP4SellOrders()-Step*MyPoint, 0, Red))
            return true;
          }
        }
      }
    }
  }
  return true;
}

int modifyAllAtHigh()
{
  double Divergence=avgOPP4BuyOrders()-avgOPP4SellOrders();
  double BuyOPP=avgOPP4BuyOrders();
  double SellOPP=avgOPP4SellOrders();
  
  if(OrdersTotal()>1)
  {
    for(int i=OrdersTotal()-1; i>=0; i--)
    {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
        if(OrderType()==OP_BUY)
        {
          if(OrderTakeProfit()!=BuyOPP+Divergence+((Ask-Bid)*3))
          {
            if(OrderModify(OrderTicket(), OrderOpenPrice(), 0, BuyOPP+Divergence+((Ask-Bid)*3), 0, Red))
            return true;
          }
        }
        
        if(OrderType()==OP_SELL)
        {
          if(OrderStopLoss()!=(SellOPP+((Ask-Bid)*4))+(Divergence*2))
          {
            if(OrderModify(OrderTicket(), OrderOpenPrice(), (SellOPP+((Ask-Bid)*4))+(Divergence*2), 0, 0, Red))
            return true;
          }
        }
      }
    }
  }
  return true;
}

int modifyAllAtLow()
{
  double Divergence=avgOPP4BuyOrders()-avgOPP4SellOrders();
  double BuyOPP=avgOPP4BuyOrders();
  double SellOPP=avgOPP4SellOrders();
  
  if(OrdersTotal()>1)
  {
    for(int i=OrdersTotal()-1; i>=0; i--)
    {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
        if(OrderType()==OP_BUY)
        {
          if(OrderStopLoss()!=(BuyOPP-((Ask-Bid)*4))-(Divergence*2))
          {
            if(OrderModify(OrderTicket(), OrderOpenPrice(), (BuyOPP-((Ask-Bid)*4))-(Divergence*2), 0, 0, Red))
            return true;
          }
        }
        if(OrderType()==OP_SELL)
        {
          if(OrderTakeProfit()!=SellOPP-Divergence-((Ask-Bid)*3))
          {
            if(OrderModify(OrderTicket(), OrderOpenPrice(), 0, SellOPP-Divergence-((Ask-Bid)*3), 0, Red))
            return true;
          }
        }
      }
    }
  }
  return true;
}

double maxLot()
{
  double mLot=0;
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      mLot=MathMax(mLot, OrderLots());
    }
  }
  return mLot;
}